#include "mbed.h"
#include "stdio.h"
#include "cstdlib"
#include "iostream"
#include "math.h"
#include "TextLCD.h"

#include "Serial.h"

using namespace std;

AnalogIn Volt(PTB3);

TextLCD lcd(PTA13,PTD2,PTD4,PTD6,PTD7,PTD5,TextLCD :: LCD20x4);

BusOut Dig(PTA12,PTD3,PTA2,PTA1);
BusOut Seg(PTC0,PTC6,PTC4,PTB19,PTC7,PTC11,PTC10,PTB18);

int D[] = { 0x08,0x04,0x02,0x01 };
        //  0    1    2    3    4    5    6    7    8    9
int S[] = {0x81,0xE7,0x49,0x43,0x27,0x13,0x11,0xC7,0x01,0x03};
int P[] = {0x80,0xE6,0x48,0x42,0x26,0x12,0x10,0xC6,0x00,0x02}; //con punto decimal

struct Num
      {
          int Val;
          int Point;
          int Length;
          int Numb[20];
      };

class Display
     {
             private:
                   
                Num N;
    
             public:
                void Start();
                void Float_to_Int(float number);
                void Num_Length();
                void Number();
                void Deploy();
                     
     };
     
void Display :: Start()
    {
        for(int i=0;i<20;i++)
           { N.Numb[i]=0; }
        
        N.Length = 0;
        N.Point = 0;
        N.Val = 0;
    }     
     
void Display :: Float_to_Int(float number)
    {
       float a=1;
       N.Point=0;
       
       N.Val=int(number);
       
       while(a!=0)
            {
               a=number-float(N.Val);
               number*=10;
               N.Val=int(number);
               N.Point++;
            }
             
       a=N.Val*0.1;
       N.Val=int(a);
       N.Point-=1;
    }
    
void Display :: Num_Length()
    {
       int a=N.Val;
       N.Length=1;
          
       while(a/10>0)
            {
               a=a/10;
               N.Length++;
            }
    }

void Display :: Number()
    {
       float aux;
       int aux2,aux3,cont=0;
              
       for(int i=0;i<N.Length;i++)
          {
             
             aux3=N.Val;
             
             aux=N.Val*0.1;
             N.Val=int(aux);
             aux-=N.Val;             
             aux2=aux*10;
             
             aux=(aux3-aux2)*0.1;
             aux-=int(aux);
             aux3=aux*10;
             
             if(aux3==1){ aux2+=1; }
             else if(aux3==9){ aux2-=1; }
             
             N.Numb[cont]=aux2;
             
             cont++; 
          }
    }
    
void Display :: Deploy()
    {
          int i=0;
          
          lcd.printf("DISPLAY: " );
          for(int j=N.Length;j>=0;j--)
             { lcd.printf("%d",N.Numb[j]); }
             
          lcd.printf("\nPUNTO: %d",N.Point);
          
          while( true )
               {
                   Dig = D[i];
                      
                   if(N.Point==2 && Dig==D[0])
                     {   
                       Seg = P[N.Numb[3-i]];  
                       wait_ms(1);
                       i++;
                       Dig = D[i]; 
                     }
                   
                   else if(N.Point!=0 && (3-i)==N.Point)
                     { 
                       Seg = P[N.Numb[3-i]];
                       
                       wait_ms(1);
                       i++;
                       Dig = D[i]; 
                     }
                   
                   Seg = S[N.Numb[3-i]]; 
                   
                   wait_ms(1);
        
                   i++;
                 
                   if(i==4){ i=0; }
               }
    } 

int main()
{
    
    Display A;
    float a;
    
    a=Volt.read()*3.3;
    
    
    lcd.printf("LCD: %f\n",a);
    
    A.Start();
    A.Float_to_Int(a);
    A.Num_Length();
    A.Number();
    A.Deploy();
           
}